% sources of variation



if 0
clear
load('leedii.mat')

% estimated parameters  
  x=[  0.5848   -0.5318    0.0871   -0.0893   -0.1018   -0.2153   -0.4865    0.0241    0.1675,...
   -0.1068    8.9360    1.2265    1.5265    0.4117    0.1962   -0.4039   -0.1945   -0.2524,...
    0.0323    0.0011    0.1470    0.1958    0.0300    0.1697    0.0437   -0.0871    2.7367,...
    3.7864    5.4402]';
N=size(data,1);
prevmean=data(:,807);
prevmean=prevmean((prevmean<5),:);

building=data(:,5:9);
mkt=data(:,10:17);
year=data(:,18:28);

buildingmean=repmat(mean(building,1),N,1);
mktmean=repmat(mean(mkt,1),N,1);
yearmean=repmat(mean(year,1),N,1);
Pmean=mean(prevmean);

B1=(building-buildingmean)*x(3:7);
B=mean(B1.*B1);
M1=(mkt-mktmean)*x(8:15);
M=mean(M1.*M1)
Y1=(year-yearmean)*x(16:26);
Y=mean(Y1.*Y1)
P1=(prevmean-Pmean)*x(2);
P=mean(P1.*P1)


S=1+x(1)^2+B+M+Y+P;
% observed building characteristics
Bratio=B/S
% observed market characteristics
Mratio=M/S
% time variation
Yratio=Y/S
% differentiation
Pratio=P/S
% unobserved market fixed effect
UMratio=x(1)^2/S
% idiosyncratic building characteristics
UBratio=1/S


end   
    
             


% experiment

             
if 0
clear  
load('leedii.mat')

% estimated parameters 
  x=[  0.5848   -0.5318    0.0871   -0.0893   -0.1018   -0.2153   -0.4865    0.0241    0.1675,...
   -0.1068    8.9360    1.2265    1.5265    0.4117    0.1962   -0.4039   -0.1945   -0.2524,...
    0.0323    0.0011    0.1470    0.1958    0.0300    0.1697    0.0437   -0.0871    2.7367,...
    3.7864    5.4402];

% parameters
sigma=x(1); %s.d. of market fixed effects
alpha=x(2) ;     %coef. for previous mean
beta=x(3:15);     %coef. for observed mkt&building characteristics
tau=x(16:26)  ;  %year fixed effects 
gamma=x(27:29); %cutoffs
% gamma=x

S=1000;        %simulation number
epsilon=epsilon(1:S,:);
u=u(1:S,:);


pho=sigma*u;   % mkt fixed effects



% simulated choices
ysim=[];
% simulated prev. mean
nsim=[];

    for j=1:M
        mktj=data(data(:,2)==j,:);  % buildings in market j

        Ij=size(mktj,1);
    
        n=zeros(Ij,S);    %  previous mean. initial value:0 
        ys=[];  % simulated level
        
                 
         for i=1:Ij-1
                yi=alpha*n(i,:)+mktj(i,5:17)*beta'+mktj(i,29:806)*pho'+mktj(i,18:28)*tau'+epsilon(:,mktj(i,1))';
               [~,ys(i,:)]=histc(yi,[-1000  gamma(3) 1000]);
               ys(i,:)=(ys(i,:)==2)*4+(ys(i,:)==1);
               n(i+1,:)=mean(ys,1);         
         end
             
         
                yi=alpha*n(Ij,:)+mktj(Ij,5:17)*beta'+mktj(Ij,29:806)*pho'+mktj(Ij,18:28)*tau'+epsilon(:,mktj(Ij,1))';
               [~,ys(Ij,:)]=histc(yi,[-1000  gamma(3) 1000]);
                ys(Ij,:)=(ys(Ij,:)==2)*4+(ys(Ij,:)==1);
               
         ysim=[ysim;ys];
         nsim=[nsim;n];
    end

% C=[sum((ysim==1),1);sum((ysim==2),1)];
% Cmean=mean(C,2);
% save('counter_gamma1.mat')   2723   13211


C=[sum((ysim==1),1);sum((ysim==3),1)];
Cmean=mean(C,2);
save('counter_gamma2.mat')



%  compute the mean of number of certifications for each level
C=[sum((ysim==1),1);sum((ysim==4),1)];
Cmean=mean(C,2);
save('counter_gamma3.mat')








