  function f=leedii_newdata(x)
 

global M N  W data epsilon  u    pho
load('leedii.mat' )
% M: total number of markets
% N: total number of buildings
% W: weight matrix. inverse of covariance matrix from reduced-form
% regressions
% episilon: building idiosyncratic effects from standard normal.
% u: random variables from the standard normal.
% data: the original dataset    
    
% parameters
sigma=x(1); %s.d. of market fixed effects
alpha=x(2) ;     %coef. for previous mean
beta=x(3:15);     %coef. for observed mkt&building characteristics
tau=x(16:26)  ;  %year fixed effects 
gamma=x(27:29); %cutoffs


S=1000;        %simulation number
epsilon=epsilon(1:S,:);
u=u(1:S,:);
pho=sigma*u;   % mkt fixed effects


% simulated choices
ysim=[];
% simulated prev. mean
nsim=[];

    for j=1:M
        mktj=data(data(:,2)==j,:);  % buildings in market j

        Ij=size(mktj,1);
    
        n=zeros(Ij,S);    %  previous mean. initial value:0 
        ys=[];  % simulated level
        
                 
         for i=1:Ij-1
                yi=alpha*n(i,:)+mktj(i,5:17)*beta'+mktj(i,29:806)*pho'+mktj(i,18:28)*tau'+epsilon(:,mktj(i,1))';
               [~,ys(i,:)]=histc(yi,[-1000  gamma 1000]);
               n(i+1,:)=mean(ys,1);         
         end
             
         
                yi=alpha*n(Ij,:)+mktj(Ij,5:17)*beta'+mktj(Ij,29:806)*pho'+mktj(Ij,18:28)*tau'+epsilon(:,mktj(Ij,1))';
               [~,ys(Ij,:)]=histc(yi,[-1000  gamma 1000]);
               
         ysim=[ysim;ys];
         nsim=[nsim;n];
    end


%  compute the mean of number of certifications for each level
C=[sum((ysim==1),1);sum((ysim==2),1);sum((ysim==3),1);sum((ysim==4),1)];
Cmean=mean(C,2);
    
% drop the first entrant in each mkt, since they are not included in the regressions    
yn=[nsim ysim data(:,5:28)];
yn=yn(yn(:,1)~=0,:); 
nsim=yn(:,1:S);
ysim=yn(:,S+1:2*S);
x2=yn(:,2*S+1:2*S+24);

Nreg=size(nsim,1);

% OLS y variables. Create cell arrays
y2=reshape((ysim>nsim),Nreg*S,1);
y1=reshape(ysim,Nreg*S,1);
Y1=mat2cell(y1,[Nreg*ones(1,S)],1);
Y2=mat2cell(y2,[Nreg*ones(1,S)],1);

% Use cell arrays to compute (X'X)^-1*X'*Y
x1=[ones(Nreg*S,1)  reshape(nsim,Nreg*S,1)  repmat(x2,S,1)];
X1=mat2cell(x1,[Nreg*ones(1,S)],size(x1,2));
X1tr=cellfun(@transpose,X1,'UniformOutput', false);
temp1=cellfun(@mtimes,X1tr,X1,'UniformOutput', false);
temp2=cellfun(@inv,temp1,'UniformOutput', false);
temp3=cellfun(@mtimes,temp2,X1tr,'UniformOutput', false);
temp4=cellfun(@mtimes,temp3,Y1,'UniformOutput', false); 
temp5=cellfun(@mtimes,temp3,Y2,'UniformOutput', false);
b1=cell2mat(temp4);
b2=cell2mat(temp5);
B1=reshape(b1,26,[]);
B2=reshape(b2,26,[]);


% mean of coefficients from 1000 simulations
B1mean=mean(B1,2);
B1mean=[B1mean(2:26)' B1mean(1)];

B2mean=mean(B2,2);
B2mean=[B2mean(2:26)' B2mean(1)];


if isempty(B1)==0 && isempty(B2)==0

CC=[ 3547  5321   6095  ]-Cmean(1:3)';

D1=B1mean-B1_true;
D2=B2mean-B2_true;

f=[D1 D2]*W*[D1 D2]'+CC*CC';

else
f=10000000000000;
end


      
    